import os, time, random
from inputimeout import inputimeout, TimeoutOccurred

MENU = {
    'Espresso': {
        'Ingredients': {
            'Milk (ml)': 50,
            'Sugar (g)': 20,
            'Water (ml)': 150,
            'Coffee (g)': 90,
        },
        'Cost': 50
    },
    'Black Coffee': {
        'Ingredients': {
            'Milk (ml)': 0,
            'Sugar (g)': 20,
            'Water (ml)': 250,
            'Coffee (g)': 30,
        },
        'Cost': 25
    },
    'Coffee': {
        'Ingredients': {
            'Milk (ml)': 50,
            'Sugar (g)': 20,
            'Water (ml)': 200,
            'Coffee (g)': 30,
        },
        'Cost': 30
    },
    'Cappuccino': {
        'Ingredients': {
            'Milk (ml)': 100,
            'Sugar (g)': 20,
            'Water (ml)': 100,
            'Coffee (g)': 50,
        },
        'Cost': 40
    },
}


def option():
    maintenance_mode = False
    selected = ''

    while selected not in ('a', 'b', 'c', 'd', 'off'):
        os.system('cls')
        print(f'''
MENU options:
    
        A. Espresso     (R{MENU['Espresso']['Cost']})
        B. Black Coffee (R{MENU['Black Coffee']['Cost']})
        C. Coffee       (R{MENU['Coffee']['Cost']})
        D. Cappuccino   (R{MENU['Cappuccino']['Cost']})
            
            ''')
        selected = input('Make a selection from the above options: ').lower()

    if selected == 'a':
        selected = 'Espresso'
    elif selected == 'b':
        selected = 'Black Coffee'
    elif selected == 'c':
        selected = 'Coffee'
    elif selected == 'd':
        selected = 'Cappuccino'
    elif selected == 'off':
        maintenance_mode = True

    print(selected)
    return selected, maintenance_mode


def resources(selection, water, milk, coffee, sugar):
    if water < MENU[selection]['Ingredients']['Water (ml)']:
        return 'There is insufficient water'
    if milk < MENU[selection]['Ingredients']['Milk (ml)']:
        return 'There is insufficient milk'
    if coffee < MENU[selection]['Ingredients']['Coffee (g)']:
        return 'There is insufficient coffee'
    if sugar < MENU[selection]['Ingredients']['Sugar (g)']:
        return 'There is insufficient sugar'

    return 'Resources OK'


def pay(selection, c_01, c_02, c_05, c_1, c_2, c_5, n_10, n_20, n_50, n_100, n_200):
    os.system('cls')
    amount_due = MENU[selection]['Cost']
    not_enough = 0
    paid = 0
    change = 0
    refund = True

    c2_01 = c_01
    c2_02 = c_02
    c2_05 = c_05
    c2_1 = c_1
    c2_2 = c_2
    c2_5 = c_5
    n2_10 = n_10
    n2_20 = n_20
    n2_50 = n_50
    n2_100 = n_100
    n2_200 = n_200

    while not_enough < amount_due:
        os.system('cls')
        print(f'''
You need to pay an amount of R{amount_due}
You have inserted R{not_enough}
You have to pay insert R{amount_due - not_enough}
''')
        print(f'''
        How do you intend to pay: 
        a. R200
        b. R100
        c. R50
        d. R20
        e. R10
        f. R5
        g. R2
        h. R1
        i. 50c
        j. 20c
        k. 10c
        ''')

        try:
            insert_monies = inputimeout(prompt='Insert money now. If not exact change, insert more money (z to exit): ',
                                        timeout=20).lower()
        except TimeoutOccurred:
            return amount_due, paid, change, refund, c2_01, c2_02, c2_05, c2_1, c2_2, c2_5, n2_10, n2_20, n2_50,\
                   n2_100, n2_200

        try:
            while insert_monies not in ('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'z'):
                insert_monies = inputimeout(prompt='Money not accepted. Insert money now: ', timeout=20).lower()
        except TimeoutOccurred:
            return amount_due, paid, change, refund, c2_01, c2_02, c2_05, c2_1, c2_2, c2_5, n2_10, n2_20, n2_50,\
                   n2_100, n2_200

        if insert_monies == 'z':
            return amount_due, paid, change, refund, c2_01, c2_02, c2_05, c2_1, c2_2, c2_5, n2_10, n2_20, n2_50,\
                   n2_100, n2_200
        elif insert_monies == 'a':
            insert_monies = 200
            n_200 += 1
        elif insert_monies == 'b':
            insert_monies = 100
            n_100 += 1
        elif insert_monies == 'c':
            insert_monies = 50
            n_50 += 1
        elif insert_monies == 'd':
            insert_monies = 20
            n_20 += 1
        elif insert_monies == 'e':
            insert_monies = 10
            n_10 += 1
        elif insert_monies == 'f':
            insert_monies = 5
            c_5 += 1
        elif insert_monies == 'g':
            insert_monies = 2
            c_2 += 1
        elif insert_monies == 'h':
            insert_monies = 1
            c_1 += 1
        elif insert_monies == 'i':
            insert_monies = 0.5
            c_05 += 1
        elif insert_monies == 'j':
            insert_monies = 0.2
            c_02 += 1
        elif insert_monies == 'k':
            insert_monies = 0.1
            c_01 += 1

        not_enough += insert_monies
        paid = not_enough
        os.system('cls')

    confirm = 'n'
    while confirm != 'Y' or confirm != 'y':
        os.system('cls')
        print(f'''
Enough money has been inserted and any change will be issued once you confirm your order. 
Are you sure you want to purchase a \x1b[4;44m{selection}\x1b[0m. Once you confirm, a refund cannot be issued.
        ''')
        confirm = input('Confirm your order ("Y" for yes, "N" to issue refund): ')
        if confirm == 'Y' or confirm == 'y':
            break
        else:
            if confirm == 'n' or confirm == 'N':
                os.system('cls')
                print(f'You have cancelled your Order. A refund of {paid} has been issued')
                amount_due = 0
                paid = 0
                change = 0
                refund = True
                time.sleep(5)
                return amount_due, paid, change, refund, c2_01, c2_02, c2_05, c2_1, c2_2, c2_5, n2_10, n2_20, n2_50,\
                       n2_100, n2_200

    too_much = 0
    refund = False
    issue_change = not_enough
    if issue_change > amount_due:
        too_much = issue_change - amount_due
        change = too_much
    while too_much != 0:
        if too_much >= 100 and too_much != 0 and n_100 != 0:
            too_much -= 100
            n_100 -= 1
            continue
        if too_much >= 50 and too_much != 0 and n_50 != 0:
            too_much -= 50
            n_50 -= 1
            continue
        if too_much >= 20 and too_much != 0 and n_20 != 0:
            too_much -= 20
            n_20 -= 1
            continue
        if too_much >= 10 and too_much != 0 and n_10 != 0:
            too_much -= 10
            n_10 -= 1
            continue
        if too_much >= 5 and too_much != 0 and c_5 != 0:
            too_much -= 5
            c_5 -= 1
            continue
        if too_much >= 2 and too_much != 0 and c_2 != 0:
            too_much -= 2
            c_2 -= 1
            continue
        if too_much >= 1 and too_much != 0 and c_1 != 0:
            too_much -= 1
            c_1 -= 1
            continue
        if too_much >= 0.5 and too_much != 0 and c_05 != 0:
            too_much -= 0.5
            c_05 -= 1
            continue
        if too_much >= 0.2 and too_much != 0 and c_02 != 0:
            too_much -= 0.2
            c_02 -= 1
            continue
        if too_much >= 0.1 and too_much != 0 and c_01 != 0:
            too_much -= 0.1
            c_01 -= 1
            continue

    return amount_due, paid, change, refund, c_01, c_02, c_05, c_1, c_2, c_5, n_10, n_20, n_50, n_100, n_200


WATER_MAX = 2000
MILK_MAX = 1500
COFFEE_MAX = 1000
SUGAR_MAX = 500
water = 2000
milk = 1500
coffee = 1000
sugar = 500

n_200 = 0
n_100 = 10
n_50 = 20
n_20 = 50
n_10 = 100
c_5 = 100
c_2 = 100
c_1 = 100
c_05 = 100
c_02 = 100
c_01 = 100
cash = 0

operation = True
resource_checked = True
maintenance_mode = False
maintenance_mode_done = False

while operation:
    os.system('cls')
    maintenance_mode_done = False

    selection, maintenance_mode = option()

    while maintenance_mode:
        os.system('cls')
        print('The Coffee Machine is currently in maintenance mode. No beverage can be served at present.\n')

        print(f'''
        Resources:
        water - {water}
        milk - {milk}
        coffee - {coffee}
        sugar - {sugar}

        R200 - {n_200}
        R100 - {n_100}
        R50 - {n_50}
        R20 - {n_20}
        R10 - {n_10}
        R5 - {c_5}
        R2 - {c_2}
        R1 - {c_1}
        50c - {c_05}
        20c - {c_02}
        10c - {c_01}
        
        Cash - R{cash}

        ''')

        exit_maintenance = input('To exit maintenance, enter "done" ')
        if exit_maintenance == 'done':
            maintenance_mode = False
            maintenance_mode_done = 'done'
            os.system('cls')
            print('System is rebooting. Please wait...')
            time.sleep(5)
            break
    if maintenance_mode_done == 'done':
        continue

    enough_resources = resources(selection, water, milk, coffee, sugar)

    while resource_checked:
        if enough_resources == 'Resources OK':
            print(enough_resources)
            break
        else:
            resource_checked = False
            print(enough_resources)

            resource_check = ''
            while resource_check not in ('Y', 'y', 'N', 'n'):
                print('''
                Y: To add a resource
                N: to go back to go into maintenance
                ''')
                resource_check = input('Do you want to add a resource: ')

            if resource_check == 'n' or resource_check == 'N':
                maintenance_mode = True
                while maintenance_mode:
                    os.system('cls')
                    print(
                        'The Coffee Machine is currently in maintenance mode. No beverage can be served at present.\n')

                    print(f'''
                    Resources:
                    water - {water}
                    milk - {milk}
                    coffee - {coffee}
                    sugar - {sugar}

                    R200 - {n_200}
                    R100 - {n_100}
                    R50 - {n_50}
                    R20 - {n_20}
                    R10 - {n_10}
                    R5 - {c_5}
                    R2 - {c_2}
                    R1 - {c_1}
                    50c - {c_05}
                    20c - {c_02}
                    10c - {c_01}

                    ''')

                    exit_maintenance = input('To exit maintenance, enter "done" ')
                    if exit_maintenance == 'done':
                        maintenance_mode = False
                        os.system('cls')
                        print('System is rebooting. Please wait...')
                        time.sleep(5)
                        break
                os.system('cls')
                print('Maintenance mode has exited but the "Resource Flag" is still raised')

            print('''
            A: Only check critical
            W: Water
            M: Milk
            C: Coffee
            S: Sugar      
            ''')

            water_refill = 0
            milk_refill = 0
            coffee_refill = 0
            sugar_refill = 0
            refill = input('Which resource do you want to add: ').lower()
            while refill not in ('s', 'w', 'm', 'c', 'a'):
                refill = input('Which resource do you want to add: ')
            if refill == 'w' or water < MENU[selection]['Ingredients']['Water (ml)'] * 1.1:
                water_refill_amount = WATER_MAX - water
                print(f'There is currently {water}ml of water. You can refill upto {water_refill_amount}ml.')
                water_refill = int(input('How much water do you want to refill: '))
                while water_refill > water_refill_amount or water_refill < water_refill_amount / 2:
                    water_refill = int(input(f'Please enter a value upto a maximum of {water_refill_amount}ml: '))
                water += water_refill
                resource_checked = True
            if refill == 'm' or milk < MENU[selection]['Ingredients']['Milk (ml)'] * 1.1:
                milk_refill_amount = MILK_MAX - milk
                print(f'There is currently {milk}ml of milk. You can refill upto {milk_refill_amount}ml.')
                milk_refill = int(input('How much milk do you want to refill: '))
                while milk_refill > milk_refill_amount or milk_refill < milk_refill_amount / 2:
                    milk_refill = int(input(f'Please enter a value upto a maximum of {milk_refill_amount}ml: '))
                milk += milk_refill
                resource_checked = True
            if refill == 'c' or coffee < MENU[selection]['Ingredients']['Coffee (g)'] * 1.1:
                coffee_refill_amount = COFFEE_MAX - coffee
                print(f'There is currently {coffee}g of coffee. You can refill upto {coffee_refill_amount}g.')
                coffee_refill = int(input('How much coffee do you want to refill: '))
                while coffee_refill > coffee_refill_amount or coffee_refill < coffee_refill_amount / 2:
                    coffee_refill = int(input(f'Please enter a value upto a maximum of {coffee_refill_amount}g: '))
                coffee += coffee_refill
                resource_checked = True
            if refill == 's' or sugar < MENU[selection]['Ingredients']['Sugar (g)'] * 1.1:
                sugar_refill_amount = SUGAR_MAX - sugar
                print(f'There is currently {sugar}g of sugar. You can refill upto {sugar_refill_amount}g.')
                sugar_refill = int(input('How much sugar do you want to refill: '))
                while sugar_refill > sugar_refill_amount or sugar_refill < sugar_refill_amount / 2:
                    sugar_refill = int(input(f'Please enter a value upto a maximum of {sugar_refill_amount}g: '))
                sugar += sugar_refill
                resource_checked = True

        break

    amount_due, paid, change, refund, c_01, c_02, c_05, c_1, c_2, c_5, n_10, n_20, n_50, n_100, n_200 = pay(selection,
                                                                                                            c_01,
                                                                                                            c_02, c_05,
                                                                                                            c_1,
                                                                                                            c_2, c_5,
                                                                                                            n_10,
                                                                                                            n_20, n_50,
                                                                                                            n_100,
                                                                                                            n_200)

    cash += amount_due
    ingredients_time = random.randint(2,9)
    water_time = random.randint(2,6)
    milk_time = random.randint(2,5)
    coffee_time = random.randint(1,3)
    sugar_time = random.randint(1,2)

    if paid < amount_due:
        os.system('cls')
        print(f'Order cancelled due to a timeout or input. A refund of R{paid} has been issued')
        time.sleep(5)

    os.system('cls')

    if not refund:
        os.system('cls')
        print(f'''
{selection} order confirmed:

Preparing Ingredients
''')
        time.sleep(ingredients_time)
        os.system('cls')

        if MENU[selection]['Ingredients']['Water (ml)'] > 0:
            water -= MENU[selection]['Ingredients']['Water (ml)']
            print(f'''
{selection} order confirmed:
            
Pouring Water
''')
            time.sleep(water_time)
            os.system('cls')

        if MENU[selection]['Ingredients']['Coffee (g)'] > 0:
            coffee -= MENU[selection]['Ingredients']['Coffee (g)']
            print(f'''
{selection} order confirmed:

Adding Coffee
''')
            time.sleep(coffee_time)
            os.system('cls')

        if MENU[selection]['Ingredients']['Sugar (g)'] > 0:
            sugar -= MENU[selection]['Ingredients']['Sugar (g)']
            print(f'''
{selection} order confirmed:

Adding Sugar
''')
            time.sleep(sugar_time)
            os.system('cls')

        if MENU[selection]['Ingredients']['Milk (ml)'] > 0:
            milk -= MENU[selection]['Ingredients']['Milk (ml)']
            print(f'''
{selection} order confirmed:

Pouring Milk
''')
            time.sleep(milk_time)


        os.system('cls')
        print(f'''
        You have been served a {selection}.
        You paid R{paid}.
        Your change is R{change}.
             
        Thank you for your purchase and Enjoy!!!
        
        __________________________________________
        ''')
        time.sleep(10)
